use godot::prelude::*;
use godot::engine::{Sprite2D, ISprite2D};

struct MyExtension;

#[gdextension]
unsafe impl ExtensionLibrary for MyExtension {}

#[derive(GodotClass)]
#[class(init, base=Sprite2D)]
struct Player {
    #[export]
    speed: f64,
    #[export]
    angular_speed: f64,

    #[base]
    base: Base<Sprite2D>
}

#[godot_api]
impl ISprite2D for Player {
    /*fn init(base: Base<Sprite2D>) -> Self {
        godot_print!("Hello world!");
        Self {
            speed: 400.0,
            angular_speed: std::f64::consts::PI,
            base,
        }
    }*/

    fn process(&mut self, delta: f64) {
        let rads = (self.angular_speed * delta) as f32;
        self.base_mut().rotate(rads);
    }
}